



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>在iOS 8中使用UIAlertController</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">在iOS 8中使用UIAlertController</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:49:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>iOS 8的新特性之一就是让接口更有适应性、更灵活，因此许多视图控制器的实现方式发生了巨大的变化。全新的UIPresentationController在实现视图控制器间的过渡动画效果和自适应设备尺寸变化效果（比如说旋转）中发挥了重要的作用，它有效地节省了程序员们的工作量（天地良心啊）。还有，某些旧的UIKit控件也同样发生了许多变化，比如说Alert Views、Action Sheets、Popovers以及Search Bar Controllers。本文将会对Alert Views和Action Sheets发生的改变进行一个大致的介绍，我们会采用Objective-C和swift两种语言同时进行代码说明。</p>
<p><strong>UIAlertView</strong></p>
<p>随着苹果上次iOS 5的发布，对话框视图样式出现在了我们面前，直到现在它都没有发生过很大的变化。下面的代码片段展示了如何初始化和显示一个带有&ldquo;取消&rdquo;和&ldquo;好的&rdquo;按钮的对话框视图。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>UIAlertView&nbsp;*alertview&nbsp;=&nbsp;[[UIAlertView&nbsp;alloc]&nbsp;initWithTitle:@</code><code>"标题"</code>&nbsp;<code>message:@</code><code>"这个是UIAlertView的默认样式"</code>&nbsp;<code>delegate:self&nbsp;cancelButtonTitle:@</code><code>"取消"</code>&nbsp;<code>otherButtonTitles:@</code><code>"好的"</code><code>,&nbsp;nil];</code></div>
<div><code>[alertview&nbsp;show];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416966807353712.png" /></p>
<p>UIAlertView的默认样式</p>
<p>swift版本和Objective-C版本不同，在swift中，alertView的初始化只允许创建拥有一个取消按钮的对话框视图。或许您可以看到带有otherButtonTitles的init方法，但是很遗憾，这个方法是没有办法通过编译的。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>alertView&nbsp;=&nbsp;UIAlertView(title:&nbsp;</code><code>"标题"</code><code>,&nbsp;message:&nbsp;</code><code>"这个是UIAlertView的默认样式"</code><code>,&nbsp;delegate:&nbsp;self,&nbsp;cancelButtonTitle:&nbsp;</code><code>"取消"</code><code>)</code></div>
<div><code>alertView.show()</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416966865106412.png" /></p>
<p>swift版本的UIAlertView</p>
<p>要能够创建和上面Objective-C版本相同的对话框视图，我们可以采取曲线救国的方法，虽然麻烦了些，但是我们为了目的可以不择手段的，是吧？</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>alertView&nbsp;=&nbsp;UIAlertView()</code></div>
<div><code>alertView.delegate&nbsp;=&nbsp;self</code></div>
<div><code>alertView.title&nbsp;=&nbsp;</code><code>"标题"</code></div>
<div><code>alertView.message&nbsp;=&nbsp;</code><code>"这个是UIAlertView的默认样式"</code></div>
<div><code>alertView.addButtonWithTitle(</code><code>"取消"</code><code>)</code></div>
<div><code>alertView.addButtonWithTitle(</code><code>"好的"</code><code>)</code></div>
<div><code>alertView.show()</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>您也可以通过更改UIAlertView的alertViewStyle属性来实现输入文字、密码甚至登录框的效果。</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416966945708911.png" /></p>
<p>UIAlertView文本对话框</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416966955321003.png" /></p>
<p>UIAlertView密码对话框</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416966961499607.png" /></p>
<p>UIAlertView登录对话框</p>
<p>UIAlertViewDelegate协议拥有响应对话框视图的按钮动作的回调方法。还有当文本框内容改变时，调用alertViewShouldEnableOtherButton:方法可以让按钮动态地可用或者不可用。</p>
<p>要说明一点，苹果官方现在并不提倡在iOS 8中使用UIAlertView，取而代之的是UIAlertController。下面我们就来介绍UIAlertController的使用方法。</p>
<p><strong>UIAlertController</strong></p>
<p>在iOS 8中，UIAlertController在功能上是和UIAlertView以及UIActionSheet相同的，UIAlertController以一种模块化替换的方式来代替这两货的功能和作用。是使用对话框(alert)还是使用上拉菜单(action sheet)，就取决于在创建控制器时，您是如何设置首选样式的。</p>
<p><strong>一个简单的对话框例子</strong></p>
<p>您可以比较一下两种不同的创建对话框的代码，创建基础UIAlertController的代码和创建UIAlertView的代码非常相似：</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>UIAlertController&nbsp;*alertController&nbsp;=&nbsp;[UIAlertController&nbsp;alertControllerWithTitle:@</code><code>"标题"</code>&nbsp;<code>message:@</code><code>"这个是UIAlertController的默认样式"</code>&nbsp;<code>preferredStyle:UIAlertControllerStyleAlert];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>alertController&nbsp;=&nbsp;UIAlertController(title:&nbsp;</code><code>"标题"</code><code>,&nbsp;message:&nbsp;</code><code>"这个是UIAlertController的默认样式"</code><code>,&nbsp;preferredStyle:&nbsp;UIAlertControllerStyle.Alert)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>同创建UIAlertView相比，我们无需指定代理，也无需在初始化过程中指定按钮。不过要特别注意第三个参数，要确定您选择的是对话框样式还是上拉菜单样式。</p>
<p>通过创建UIAlertAction的实例，您可以将动作按钮添加到控制器上。UIAlertAction由标题字符串、样式以及当用户选中该动作时运行的代码块组成。通过UIAlertActionStyle，您可以选择如下三种动作样式：常规(default)、取消(cancel)以及警示(destruective)。为了实现原来我们在创建UIAlertView时创建的按钮效果，我们只需创建这两个动作按钮并将它们添加到控制器上即可。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>UIAlertAction&nbsp;*cancelAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"取消"</code>&nbsp;<code>style:UIAlertActionStyleCancel&nbsp;handler:nil];</code></div>
<div><code>UIAlertAction&nbsp;*okAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"好的"</code>&nbsp;<code>style:UIAlertActionStyleDefault&nbsp;handler:nil];</code></div>
<div><code>[alertController&nbsp;addAction:cancelAction];</code></div>
<div><code>[alertController&nbsp;addAction:okAction];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>cancelAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"取消"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Cancel,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>var</code>&nbsp;<code>okAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"好的"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Default,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>alertController.addAction(cancelAction)</code></div>
<div><code>alertController.addAction(okAction)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>最后，我们只需显示这个对话框视图控制器即可：</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>[self&nbsp;presentViewController:alertController&nbsp;animated:YES&nbsp;completion:nil];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>self.presentViewController(alertController,&nbsp;animated:&nbsp;</code><code>true</code><code>,&nbsp;completion:&nbsp;nil)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416967052393203.png" /></p>
<p>UIAlertController默认样式</p>
<p>按钮显示的次序取决于它们添加到对话框控制器上的次序。一般来说，根据苹果官方制定的《iOS 用户界面指南》，在拥有两个按钮的对话框中，您应当将取消按钮放在左边。要注意，取消按钮是唯一的，如果您添加了第二个取消按钮，那么你就会得到如下的一个运行时异常：</p>
<p>* Terminating app due to uncaught exception &lsquo;NSInternalInconsistencyException&rsquo;, reason: &lsquo;UIAlertController can only have one action with a style of UIAlertActionStyleCancel&rsquo;</p>
<p>异常信息简洁明了，我们在此就不赘述了。</p>
<p><strong>&ldquo;警示&rdquo;样式</strong></p>
<p>什么是&ldquo;警示&rdquo;样式呢？我们先不着急回答这个问题，先来看一下下面关于&ldquo;警示&rdquo;样式的简单示例。在这个示例中，我们将前面的示例中的&ldquo;好的&rdquo;按钮替换为了&ldquo;重置&rdquo;按钮。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>UIAlertAction&nbsp;*resetAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"重置"</code>&nbsp;<code>style:UIAlertActionStyleDestructive&nbsp;handler:nil];</code></div>
<div><code>[alertController&nbsp;addAction:resetAction];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>resetAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"重置"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Destructive,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>alertController.addAction(resetAction)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416967112867112.png" /></p>
<p>&ldquo;警示&rdquo;样式</p>
<p>可以看出，我们新增的那个&ldquo;重置&rdquo;按钮变成了红色。根据苹果官方的定义，&ldquo;警示&rdquo;样式的按钮是用在可能会改变或删除数据的操作上。因此用了红色的醒目标识来警示用户。</p>
<p><strong>文本对话框</strong></p>
<p>UIAlertController极大的灵活性意味着您不必拘泥于内置样式。以前我们只能在默认视图、文本框视图、密码框视图、登录和密码输入框视图中选择，现在我们可以向对话框中添加任意数目的UITextField对象，并且可以使用所有的UITextField特性。当您向对话框控制器中添加文本框时，您需要指定一个用来配置文本框的代码块。</p>
<p>举个栗子吧，要重新建立原来的登录和密码样式对话框，我们可以向其中添加两个文本框，然后用合适的占位符来配置它们，最后将密码输入框设置使用安全文本输入。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
</td>
<td>
<div>
<div><code>UIAlertController&nbsp;*alertController&nbsp;=&nbsp;[UIAlertController&nbsp;alertControllerWithTitle:@</code><code>"文本对话框"</code>&nbsp;<code>message:@</code><code>"登录和密码对话框示例"</code>&nbsp;<code>preferredStyle:UIAlertControllerStyleAlert];</code></div>
<div><code>[alertController&nbsp;addTextFieldWithConfigurationHandler:^(UITextField&nbsp;*textField){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.placeholder&nbsp;=&nbsp;@</code><code>"登录"</code><code>;</code></div>
<div><code>}];</code></div>
<div><code>[alertController&nbsp;addTextFieldWithConfigurationHandler:^(UITextField&nbsp;*textField)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.placeholder&nbsp;=&nbsp;@</code><code>"密码"</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.secureTextEntry&nbsp;=&nbsp;YES;</code></div>
<div><code>}];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
</td>
<td>
<div>
<div><code>alertController.addTextFieldWithConfigurationHandler&nbsp;{&nbsp;</code></div>
<div><code>(textField:&nbsp;UITextField!)&nbsp;-&gt;&nbsp;Void&nbsp;</code><code>in</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.placeholder&nbsp;=&nbsp;</code><code>"登录"</code></div>
<div><code>}</code></div>
<div><code>alertController.addTextFieldWithConfigurationHandler&nbsp;{&nbsp;</code></div>
<div><code>(textField:&nbsp;UITextField!)&nbsp;-&gt;&nbsp;Void&nbsp;</code><code>in</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.placeholder&nbsp;=&nbsp;</code><code>"密码"</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>textField.secureTextEntry&nbsp;=&nbsp;</code><code>true</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在&ldquo;好的&rdquo;按钮按下时，我们让程序读取文本框中的值。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>UIAlertAction&nbsp;*okAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"好的"</code>&nbsp;<code>style:UIAlertActionStyleDefault&nbsp;handler:^(UIAlertAction&nbsp;*action)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>UITextField&nbsp;*login&nbsp;=&nbsp;alertController.textFields.firstObject;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>UITextField&nbsp;*password&nbsp;=&nbsp;alertController.textFields.lastObject;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>...</code></div>
<div><code>}];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>okAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"好的"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Default)&nbsp;{</code></div>
<div><code>(action:&nbsp;UIAlertAction!)&nbsp;-&gt;&nbsp;Void&nbsp;</code><code>in</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>login&nbsp;=&nbsp;alertController.textFields?.first&nbsp;as&nbsp;UITextField</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>password&nbsp;=&nbsp;alertController.textFields?.last&nbsp;as&nbsp;UITextField</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>如果我们想要实现UIAlertView中的委托方法alertViewShouldEnableOtherButton:方法的话可能会有一些复杂。假定我们要让&ldquo;登录&rdquo;文本框中至少有3个字符才能激活&ldquo;好的&rdquo;按钮。很遗憾的是，在UIAlertController中并没有相应的委托方法，因此我们需要向&ldquo;登录&rdquo;文本框中添加一个Observer。Observer模式定义对象间的一对多的依赖关系,当一个对象的状态发生改变时, 所有依赖于它的对象都得到通知并被自动更新。我们可以在构造代码块中添加如下的代码片段来实现。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>[alertController&nbsp;addTextFieldWithConfigurationHandler:^(UITextField&nbsp;*textField){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[[NSNotificationCenter&nbsp;defaultCenter]&nbsp;addObserver:self&nbsp;selector:@selector(alertTextFieldDidChange:)&nbsp;name:UITextFieldTextDidChangeNotification&nbsp;object:textField];</code></div>
<div><code>}];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>alertController.addTextFieldWithConfigurationHandler&nbsp;{</code></div>
<div><code>(textField:&nbsp;UITextField!)&nbsp;-&gt;&nbsp;Void&nbsp;</code><code>in</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSNotificationCenter.defaultCenter().addObserver(self,&nbsp;selector:&nbsp;Selector(</code><code>"alertTextFieldDidChange:"</code><code>),&nbsp;name:&nbsp;UITextFieldTextDidChangeNotification,&nbsp;object:&nbsp;textField)</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>当视图控制器释放的时候我们需要移除这个Observer，我们通过在每个按钮动作的handler代码块（还有其他任何可能释放视图控制器的地方）中添加合适的代码来实现它。比如说在okAction这个按钮动作中：</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>UIAlertAction&nbsp;*okAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"好的"</code>&nbsp;<code>style:UIAlertActionStyleDefault&nbsp;handler:^(UIAlertAction&nbsp;*action)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[[NSNotificationCenter&nbsp;defaultCenter]&nbsp;removeObserver:self&nbsp;name:UITextFieldTextDidChangeNotification&nbsp;object:nil];</code></div>
<div><code>}];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>okAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"好的"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Default)&nbsp;{</code></div>
<div><code>(action:&nbsp;UIAlertAction!)&nbsp;-&gt;&nbsp;Void&nbsp;</code><code>in</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSNotificationCenter.defaultCenter().removeObserver(self,&nbsp;name:&nbsp;UITextFieldTextDidChangeNotification,&nbsp;object:&nbsp;nil)</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在显示对话框之前，我们要冻结&ldquo;好的&rdquo;按钮</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>okAction.enabled&nbsp;=&nbsp;NO;</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>okAction.enabled&nbsp;=&nbsp;</code><code>false</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>接下来，在通知观察者（notification observer）中，我们需要在激活按钮状态前检查&ldquo;登录&rdquo;文本框的内容。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)alertTextFieldDidChange:(NSNotification&nbsp;*)notification{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>UIAlertController&nbsp;*alertController&nbsp;=&nbsp;(UIAlertController&nbsp;*)self.presentedViewController;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(alertController)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>UITextField&nbsp;*login&nbsp;=&nbsp;alertController.textFields.firstObject;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>UIAlertAction&nbsp;*okAction&nbsp;=&nbsp;alertController.actions.lastObject;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>okAction.enabled&nbsp;=&nbsp;login.text.length&nbsp;&gt;&nbsp;2;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
</td>
<td>
<div>
<div><code>func&nbsp;alertTextFieldDidChange(notification:&nbsp;NSNotification){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>alertController&nbsp;=&nbsp;self.presentedViewController&nbsp;as&nbsp;UIAlertController?</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(alertController&nbsp;!=&nbsp;nil)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>login&nbsp;=&nbsp;alertController!.textFields?.first&nbsp;as&nbsp;UITextField</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>okAction&nbsp;=&nbsp;alertController!.actions.last&nbsp;as&nbsp;UIAlertAction</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>okAction.enabled&nbsp;=&nbsp;countElements(login.text)&nbsp;&gt;&nbsp;2</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416967618423000.png" /></p>
<p>UIAlertController的登录和密码对话框示例</p>
<p>好了，现在对话框的&ldquo;好的&rdquo;按钮被冻结了，除非在&ldquo;登录&rdquo;文本框中输入3个以上的字符：</p>
<p><strong>上拉菜单</strong></p>
<p>当需要给用户展示一系列选择的时候（选择恐惧症患者杀手），上拉菜单就能够派上大用场了。和对话框不同，上拉菜单的展示形式和设备大小有关。在iPhone上（紧缩宽度），上拉菜单从屏幕底部升起。在iPad上（常规宽度），上拉菜单以弹出框的形式展现。</p>
<p>创建上拉菜单的方式和创建对话框的方式非常类似，唯一的区别是它们的形式。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>UIAlertController&nbsp;*alertController&nbsp;=&nbsp;[UIAlertController&nbsp;alertControllerWithTitle:@</code><code>"保存或删除数据"</code>&nbsp;<code>message:@</code><code>"删除数据将不可恢复"</code>&nbsp;<code>preferredStyle:&nbsp;UIAlertControllerStyleActionSheet];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>alertController&nbsp;=&nbsp;UIAlertController(title:&nbsp;</code><code>"保存或删除数据"</code><code>,&nbsp;message:&nbsp;</code><code>"删除数据将不可恢复"</code><code>,&nbsp;preferredStyle:&nbsp;UIAlertControllerStyle.ActionSheet)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>添加按钮动作的方式和对话框相同。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>UIAlertAction&nbsp;*cancelAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"取消"</code>&nbsp;<code>style:UIAlertActionStyleCancel&nbsp;handler:nil];</code></div>
<div><code>UIAlertAction&nbsp;*deleteAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"删除"</code>&nbsp;<code>style:UIAlertActionStyleDestructive&nbsp;handler:nil];</code></div>
<div><code>UIAlertAction&nbsp;*archiveAction&nbsp;=&nbsp;[UIAlertAction&nbsp;actionWithTitle:@</code><code>"保存"</code>&nbsp;<code>style:UIAlertActionStyleDefault&nbsp;handler:nil];</code></div>
<div><code>[alertController&nbsp;addAction:cancelAction];</code></div>
<div><code>[alertController&nbsp;addAction:deleteAction];</code></div>
<div><code>[alertController&nbsp;addAction:archiveAction];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>cancelAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"取消"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Cancel,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>var</code>&nbsp;<code>deleteAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"删除"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Destructive,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>var</code>&nbsp;<code>archiveAction&nbsp;=&nbsp;UIAlertAction(title:&nbsp;</code><code>"保存"</code><code>,&nbsp;style:&nbsp;UIAlertActionStyle.Default,&nbsp;handler:&nbsp;nil)</code></div>
<div><code>alertController.addAction(cancelAction)</code></div>
<div><code>alertController.addAction(deleteAction)</code></div>
<div><code>alertController.addAction(archiveAction)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>您不能在上拉菜单中添加文本框，如果您强行作死添加了文本框，那么就会荣幸地得到一个运行时异常：</p>
<p>* Terminating app due to uncaught exception &lsquo;NSInternalInconsistencyException&rsquo;, reason: &lsquo;Text fields can only be added to an alert controller of style UIAlertControllerStyleAlert&rsquo;</p>
<p>同样，简单的异常说明，我们也不多说了。</p>
<p>接下来我们就可以在iPhone或者其他紧缩宽度的设备上展示了，不出我们所料，运行得很成功。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>[self&nbsp;presentViewController:alertController&nbsp;animated:YES&nbsp;completion:nil];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>self.presentViewController(alertController,&nbsp;animated:&nbsp;</code><code>true</code><code>,&nbsp;completion:&nbsp;nil)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416967563883898.png" /></p>
<p>iPhone上的上拉菜单效果</p>
<p>如果上拉菜单中有&ldquo;取消&rdquo;按钮的话，那么它永远都会出现在菜单的底部，不管添加的次序是如何（就是这么任性）。其他的按钮将会按照添加的次序从上往下依次显示。《iOS 用户界面指南》要求所有的&ldquo;毁坏&rdquo;样式按钮都必须排名第一（红榜嘛，很好理解的，对不对？）。</p>
<p>别激动得太早，我们现在还有一个很严重的问题，这个问题隐藏得比较深。当我们使用iPad或其他常规宽度的设备时，就会得到一个运行时异常：</p>
<p>Terminating app due to uncaught exception &lsquo;NSGenericException&rsquo;, reason: &lsquo;UIPopoverPresentationController (&lt;_uialertcontrolleractionsheetregularpresentationcontroller: 0x7fc619588110=""&gt;) should have a non-nil sourceView or barButtonItem set before the presentation occurs.&rsquo;</p>
<p>就如我们之前所说，在常规宽度的设备上，上拉菜单是以弹出框的形式展现。弹出框必须要有一个能够作为源视图或者栏按钮项目的描点(anchor point)。由于在本例中我们是使用了常规的UIButton来触发上拉菜单的，因此我们就将其作为描点。</p>
<p>在iOS 8中我们不再需要小心翼翼地计算出弹出框的大小，UIAlertController将会根据设备大小自适应弹出框的大小。并且在iPhone或者紧缩宽度的设备中它将会返回nil值。配置该弹出框的代码如下：</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>UIPopoverPresentationController&nbsp;*popover&nbsp;=&nbsp;alertController.popoverPresentationController;</code></div>
<div><code>if</code>&nbsp;<code>(popover){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover.sourceView&nbsp;=&nbsp;sender;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover.sourceRect&nbsp;=&nbsp;sender.bounds;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover.permittedArrowDirections&nbsp;=&nbsp;UIPopoverArrowDirectionAny;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>var</code>&nbsp;<code>popover&nbsp;=&nbsp;alertController.popoverPresentationController</code></div>
<div><code>if</code>&nbsp;<code>(popover&nbsp;!=&nbsp;nil){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover?.sourceView&nbsp;=&nbsp;sender</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover?.sourceRect&nbsp;=&nbsp;sender.bounds</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>popover?.permittedArrowDirections&nbsp;=&nbsp;UIPopoverArrowDirection.Any</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/20141126/1416967530355906.png" /></p>
<p>iPad上的上拉菜单效果</p>
<p>UIPopoverPresentationController类同样也是在iOS 8中新出现的类，用来替换UIPopoverController的。这个时候上拉菜单是以一个固定在源按钮上的弹出框的形式显示的。</p>
<p>要注意UIAlertController在使用弹出框的时候自动移除了取消按钮。用户通过点击弹出框的外围部分来实现取消操作，因此取消按钮便不再必需。</p>
<p><strong>释放对话框控制器</strong></p>
<p>通常情况下，当用户选中一个动作后对话框控制器将会自行释放。不过您仍然可以在需要的时候以编程方式释放它，就像释放其他视图控制器一样。您应当在应用程序转至后台运行时移除对话框或者上拉菜单。假定我们正在监听UIApplicationDidEnterBackgroundNotification通知消息，我们可以在observer中释放任何显示出来的视图控制器。（参考在viewDidLoad方法中设立observer的示例代码）。</p>
<p>Objective-C版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)didEnterBackground:(NSNotification&nbsp;*)notification</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;</code><code>[[NSNotificationCenter&nbsp;defaultCenter]&nbsp;removeObserver:self&nbsp;name:UITextFieldTextDidChangeNotification&nbsp;object:nil];</code></div>
<div><code>&nbsp;&nbsp;</code><code>[self.presentedViewController&nbsp;dismissViewControllerAnimated:NO&nbsp;completion:nil];</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>swift版本：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>func&nbsp;didEnterackground(notification:&nbsp;NSNotification){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSNotificationCenter.defaultCenter().removeObserver(self,&nbsp;name:&nbsp;UITextFieldTextDidChangeNotification,&nbsp;object:&nbsp;nil)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>self.presentedViewController?.dismissViewControllerAnimated(</code><code>false</code><code>,&nbsp;completion:&nbsp;nil)</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>注意，要保证运行安全我们同样要确保移除所有的文本框observer。</p>
<p><strong>我们来总结一下</strong></p>
<p>这篇文章比较长，但是希望能够对您有所帮助。原先的UIAlertView和UIActionSheet类仍然可以在iOS 8中工作得很好，所以没有必要急于更换代码（要知道本文用到的许多函数尽在iOS 8中支持）。本文的代码可以在我的Github主页上找到，包括了AlertController - ObjC以及AlertController - swift。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e44rz9.html">SQL Server 2016中In-Memory OLTP继CTP3之后的新改进</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy0oxj8.html">iOS阶段学习第28天笔记&lpar;UIView的介绍&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2vkzw8.html">Elasticsearch&colon; Indexing SQL databases&period; The easy way</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96n5wnq.html">Ajax 无刷新上传文件插件 uploadify 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v2dvj8.html">响应式Web设计基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1zm48.html">&lpar;转&rpar;使用getevent监听Android输入设备文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1k3p69.html">3&period;5 spring-replaced-method 子元素的使用与解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjgve8.html">要想重启后也生效LINUX防火墙配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm22y79.html">正式学习React&lpar;一&rpar; 开始学习之前必读</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnow4oq.html">BZOJ 4199&colon; &lbrack;Noi2015&rsqb;品酒大会&lpar; 后缀数组 &plus; 并查集 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1glkjq.html">C&num;控制台应用程序之旅游资源与线路管理系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/950eoe08.html">Redis~Linux环境下的部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgogmr8.html">Ansible第二章：palybook介绍与使用--小白博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvyk48.html">Windows Server 2016-增强IPAM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605oov9.html">Ridis</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwo3v09.html">vetur插件提示 &lbrack;vue-language-server&rsqb; Elements in iteration expect to have &amp;&num;39&semi;v-bind&colon;key&amp;&num;39&semi; directives错误的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6m1n9.html">centos6&period;5 yum安装redis</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p4ggeq.html">mysql数据库中查看当前使用的数据库是哪个数据库？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj17po8.html">【第二周】Java实现英语文章词频统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kmnrlj9.html">Linux命令之locate</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rql4gy09.html">【&period;Net底层剖析】2&period;stfld指令-给对象的字段赋值</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8evdle9.html">二叉堆&lpar;一&rpar;之 图文解析 和 C语言的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/495o5we8.html">4、总结：基于Oracle Logminer数据同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96e6kjq.html">Tools - Oracle SQL Developer</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2pdmw8.html">Javascript面向对象之继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4lgne8.html">Direct3D11学习：（一）开发环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z0oj3q.html">Spring重点&mdash;&mdash; IOC 容器中 Bean 的生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/49goe54q.html">领域驱动设计&lpar;DDD&rpar;实现之路</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd7pl0q.html">点餐APP  冲刺一总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kxjd5q.html">Linq专题之对象初始化器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
